<?php
	if(!defined('PLX_ROOT')) exit;
	/**
		* Plugin 			membersOnly
		*
		* @CMS required			PluXml 
		* @page				admin.php
		* @version			2.0.4
		* @date				20/02/2025
		* @author 			Gcyrillus
		░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
		░       ░░  ░░░░░░░  ░░░░  ░  ░░░░  ░░      ░░       ░░░      ░░  ░░░░░░░        ░░      ░░░░░   ░░░  ░        ░        ░
		▒  ▒▒▒▒  ▒  ▒▒▒▒▒▒▒  ▒▒▒▒  ▒▒  ▒▒  ▒▒  ▒▒▒▒  ▒  ▒▒▒▒  ▒  ▒▒▒▒  ▒  ▒▒▒▒▒▒▒▒▒▒  ▒▒▒▒  ▒▒▒▒▒▒▒▒▒▒    ▒▒  ▒  ▒▒▒▒▒▒▒▒▒▒  ▒▒▒▒
		▓       ▓▓  ▓▓▓▓▓▓▓  ▓▓▓▓  ▓▓▓    ▓▓▓  ▓▓▓▓  ▓       ▓▓  ▓▓▓▓  ▓  ▓▓▓▓▓▓▓▓▓▓  ▓▓▓▓▓      ▓▓▓▓▓  ▓  ▓  ▓      ▓▓▓▓▓▓  ▓▓▓▓
		█  ███████  ███████  ████  ██  ██  ██  ████  █  ███████  ████  █  ██████████  ██████████  ████  ██    █  ██████████  ████
		█  ███████        ██      ██  ████  ██      ██  ████████      ██        █        ██      ██  █  ███   █        ████  ████
		█████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████
	**/	
	# Control du token du formulaire
	plxToken::validateFormToken($_POST);
	
	# config pagination
	if(isset($_POST['paginate'] )){
		$plxPlugin->setParam('paginate', $_POST['paginate'], 'numeric');
		$plxPlugin->saveParams();
		header("Location: plugin.php?p=".basename(__DIR__));
		exit;
	}
	# profils utilisateurs
	# Tableau des profils
	$aProfils = array(
		PROFIL_ADMIN => L_PROFIL_ADMIN,
		PROFIL_MANAGER => L_PROFIL_MANAGER,
		PROFIL_MODERATOR => L_PROFIL_MODERATOR,
		PROFIL_EDITOR => L_PROFIL_EDITOR,
		PROFIL_WRITER => L_PROFIL_WRITER
	);
	if(isset($plxAdmin->plxPlugins->aPlugins['StaticMiniForum'])) {
		$plugInstance=$plxAdmin->plxPlugins->getInstance('StaticMiniForum');
		$aProfils = $plugInstance->memberProfils;
	}
	#inversion du tableau pour des raisons pratiques
	$aProfils=array_reverse($aProfils,true);
	$profilTypes =count($aProfils);
	
	# Liste des langues disponibles et prises en charge par le plugin
	$aLangs = array($plxAdmin->aConf['default_lang']);	
	# init vars / remove unecessary
	
	# initialisation des variables propres à chaque lanque
	$langs = array();
	foreach($aLangs as $lang) {
		# chargement de chaque fichier de langue
		$langs[$lang] = $plxPlugin->loadLang(PLX_PLUGINS.'excludeFromVisitors/lang/'.$lang.'.php');
		$var[$lang]['mnuName'] =  $plxPlugin->getParam('mnuName_'.$lang)=='' ? $plxPlugin->getLang('L_DEFAULT_MENU_NAME') : $plxPlugin->getParam('mnuName_'.$lang);
	}	
	
	$profilsHeader='';
	foreach($aProfils as $type => $profil) {
			$profilsHeader .= '<th>'.$profil.'</th>';
	}
	$tableStats='<table id="tableStats">'.PHP_EOL;
	$open = '<thead><tr><th>'.L_SEARCH_PLACEHOLDER.' <sup></sup></td><th>'.L_ARTICLES_FILTER_BUTTON.'</th>'.$profilsHeader.'</tr></thead><tbody>';
	$close='</tbody></table>';
	$by10=$by30=$by50=$by100=$by250='';
	${'by'.$plxPlugin->paginateBy}='class="checked"';
	$nav='<nav class="pagination-container">
				<button class="pagination-button" id="prev-button" aria-label="Previous page" title="Previous page">&lt;</button>
				<div id="pagination-numbers"></div>
				<button class="pagination-button" id="next-button" aria-label="Next page" title="Next page">&gt;</button>
			</nav>
				<div style="text-align:end;padding: .5em 0;">'. L_CONFIG_VIEW_BYPAGE .'
				<input type="submit" value="10"  '.$by10 .' name="paginate">
				<input type="submit" value="30"  '.$by30 .' name="paginate">
				<input type="submit" value="50"  '.$by50 .' name="paginate">
				<input type="submit" value="100" '.$by100.' name="paginate">
				<input type="submit" value="250" '.$by250.' name="paginate">
				</div>';

	# liste des pages statiques et filtres
	$filters=$filter= $num = $level =array();
	$stats = $plxAdmin->aStats;
	$statsPage="";
	$start="";
	$end="";
	if($plxPlugin->statiques !=null && trim($plxPlugin->statiques) !='') {
		$filter = json_decode($plxPlugin->statiques,true);
		foreach($filter as $filters){
			$filters= explode(',',$filters);
			if(isset($filters[0]) && !isset($filters[1])) $filters[1] =1;// defaut profil gestionnaire
			if(isset($filters[0]) && ($filters[1] == $profilTypes || !isset($filters[1]) || $filters[1]=='')) $filters[1] = 4;
			$num[]		= $filters[0];
			$level[$filters[0]]	= $filters[1];		
		}

	}
		$start=$tableStats.$open;
		$end=$close;
	$statsPage.=$start;
	foreach($plxAdmin->aStats as $stat_num => $stat_info) {
		$checked="";
		$levelChecked="";
		$radioProfils='';
		if(is_array($num) && in_array($stat_num,$num)) $checked=" checked ";
		foreach($aProfils as $lev => $str) {
			$levelChecked="";
			if(isset($level[$stat_num])) {
				if($lev == $level[$stat_num]) {
					$levelChecked="checked";
				}

			}
			$radioProfils .='<td class="rp"><input type="radio" name="radioGroup-'.$stat_num.'" id="radio-'.$stat_num.$lev.'" '.$levelChecked.' value="'.$lev.'"> <sup>('.$lev.')</sup></td>'.PHP_EOL;
		}
		$statsPage .='
		<tr>
		<td><label for="stat-'.$stat_num.'" title="'. $stat_info['name'].'"> N°<b>'.$stat_num.'</b> - '. $stat_info['name'].'</label></td>
		<td><input type="checkbox" id ="stat-'.$stat_num.'" name="statiquesPages[]" '.$checked.' value="'.$stat_num.'" data-group="'.$stat_info['group'].'"></td>
		'.$radioProfils.'
		</tr>';                                
		
	}
	$statsPage.=$end;	
	
	
	# liste des articles et filtres
	$filters=$filter= $num = $level =array();
	$arts= $plxAdmin->plxGlob_arts->aFiles;	
	$articlePage="";
	$start="";
	$end="";
	if($plxPlugin->articles != null && trim($plxPlugin->articles) !='') {
		$filter = json_decode($plxPlugin->articles,true);
		foreach($filter as $filters){
			$filters= explode(',',$filters);
			if(isset($filters[0]) && !isset($filters[1])) $filters[1] =1;// defaut profil gestionnaire
			if(isset($filters[0]) && ( !isset($filters[1])|| $filters[1] == $profilTypes || $filters[1]=='')) $filters[1] = 4;
			$num[]		= $filters[0];
			$level[$filters[0]]	= $filters[1];		
		}
	}
		$tableStats='<table id="tableArts">'.PHP_EOL;
		$start=$open;
		$end=$close;
		$articlePage.=$tableStats.$start;
		foreach($plxAdmin->plxGlob_arts->aFiles as $art_num => $filename) {
			$checked="";
			$draft='';
			if(is_array($filter) && in_array($art_num,$num)) $checked=" checked ";
			$art = $plxAdmin->parseArticle(PLX_ROOT.'data/articles/'.$filename);
			if(strpos($filename, 'draft') !== false) $draft='class="draft"';
			$radioarts='';
		foreach($aProfils as $lev => $str) {
			$levelChecked="";
			if(isset($level[$art_num])) {
				if($lev == $level[$art_num]) {
					$levelChecked="checked";
				}
			}
			$radioarts .=PHP_EOL.'<td class="rp"><input type="radio" name="radioArt-'.$art_num.'" id="radio-'.$art_num.$lev.'" '.$levelChecked.' value="'.$lev.'"> '.$lev.'</td>'.PHP_EOL;
		}
			
			
			$articlePage .='
			<tr>
			<td><label for="art-'.$art_num.'" '.$draft.'>N°<b>'.$art_num.'</b> - '. $art['title'].'</label></td>
			<td><input type="checkbox" id ="art-'.$art_num.'" name="articles[]" '.$checked.' value="'.$art_num.'"></td>'.
			$radioarts.'
			</tr>';                                
			
		}
		$articlePage.=$end.PHP_EOL.$nav;
	
	
	# liste des catégories et filtres
	$filter=array();
	$filters=$filter= $num = $level =array();
	$cats = $plxAdmin->aCats;	
	$categoriePage="";
	
	if($plxPlugin->categories != null && trim($plxPlugin->categories) !='') {
		$filter = json_decode($plxPlugin->categories,true);
		foreach($filter as $filters){
			$filters= explode(',',$filters);
			if(isset($filters[0]) && !isset($filters[1])) $filters[1] =1;// defaut profil gestionnaire
			if(isset($filters[0]) && ( !isset($filters[1])|| $filters[1] >= $profilTypes || $filters[1]=='')) $filters[1] = 4;
			$num[]		= $filters[0];
			$level[$filters[0]]	= $filters[1];
		}
	}
		$tableStats='<table id="tableCats">'.PHP_EOL;
		$start=$open;
		$end=$close;
		$categoriePage.=$tableStats.$start;
		foreach($plxAdmin->aCats as $cat_num => $infos) {
			$checked="";
			if(is_array($filter) && in_array($cat_num,$num)) $checked=" checked ";
			$radiocats='';
			foreach($aProfils as $lev => $str) {
				$levelChecked="";
				if(isset($level[$cat_num])) {
					if($lev == $level[$cat_num]) {
						$levelChecked="checked";
					}
				}
				$radiocats .='<td class="rp"><input type="radio" name="radioCats-'.$cat_num.'" id="radio-'.$cat_num.$lev.'" '.$levelChecked.' value="'.$lev.'"> '.$lev.'</td>'.PHP_EOL;
			}			
			$categoriePage .='
			<tr>
			<td><label for="cat-'.$cat_num.'">N°<b>'.$cat_num.'</b> - '. $infos['name'].'</label></td>
			<td><input type="checkbox" id ="cat-'.$cat_num.'" name="categories[]" '.$checked.' value="'.$cat_num.'"></td>'.
			$radiocats.'
			</tr>'; 
		}
		$categoriePage .=$end;
	
	
	if(!empty($_POST)) {
		if(!isset($_POST['statiquesPages'])) 
			$_POST['statiquesPages'] =array();

		$stats=json_encode($_POST['statiquesPages'],true);
		$staticsPage=array();
		foreach($_POST['statiquesPages'] as $k => $statnum) {
			$id=intval($statnum);
			if(isset($_POST['radioGroup-'.str_pad($id,3,'0', STR_PAD_LEFT)])) {
				$profilLevel = intval($_POST['radioGroup-'.str_pad($id,3,'0', STR_PAD_LEFT)]);
				if($profilLevel == $profilTypes || $profilLevel =='') $profilLevel = $profilTypes-1;
				$staticsPage[$k] = $statnum .','.intval($profilLevel);
			}
		}
		$plxPlugin->setParam('statiques', json_encode($staticsPage,true),'cdata');

		if(!isset($_POST['articles'])) 
			$_POST['articles']=array();
		$arArticles=$_POST['articles'];
		if(in_array(substr('radioArt-',0,9),$_POST ))$arArticles=array();
		$articles = json_encode($_POST['articles'],true);
		foreach($_POST['articles'] as $art => $artnum) {
			$idart=intval($artnum);
			$arArticles[$art] = $idart;
			if(isset($_POST['radioArt-'.str_pad($idart,4,'0', STR_PAD_LEFT)])) {
				$profilLevel = intval($_POST['radioArt-'.str_pad($idart,4,'0', STR_PAD_LEFT)]);
				echo intval($_POST['radioArt-'.str_pad($idart,4,'0', STR_PAD_LEFT)]).' - ';
				if($profilLevel == $profilTypes || $profilLevel =='') $profilLevel = $profilTypes-1;
				$arArticles[$art] = $artnum .','.intval($profilLevel);
			}
		}
		$plxPlugin->setParam('articles', json_encode($arArticles,true), 'cdata');
		

		if(!isset($_POST['categories'])) 
			$_POST['categories'] = array();

		$cats=json_encode($_POST['categories'],true);
		$catsPage=array();
		foreach($_POST['categories'] as $k => $catnum) {
			$idcat=intval($catnum);
			if(isset($_POST['radioCats-'.str_pad($idcat,3,'0', STR_PAD_LEFT)])) {
				$profilLevel = intval($_POST['radioCats-'.str_pad($idcat,3,'0', STR_PAD_LEFT)]);
				if($profilLevel == $profilTypes || $profilLevel =='') $profilLevel = $profilTypes-1;
				$catsPage[$k] = $catnum .','.intval($profilLevel);
			}
		}
		$plxPlugin->setParam('categories', json_encode($catsPage,true), 'cdata');
				
		$plxPlugin->saveParams();
		header("Location: plugin.php?p=".basename(__DIR__));
		exit;
	}
	
?>
<link rel="stylesheet" href="<?php echo PLX_PLUGINS."excludeFromVisitors/css/tabs.css" ?>" media="all" />
<h2><?php $plxPlugin->lang("L_ADMIN") ?></h2>
<style>

fieldset,
details summary {
  all: revert;
}
details .grid {
  max-width: 100%;
  padding: 0 1em;
  display: grid;
  grid-template-columns: repeat(auto-fit, minmax(12em, 1fr));
  gap: 0.5em 1em;
}
details .grid p {
  display: flex;
  gap: 0.25em;
  max-width: 100%;
  padding: 0 0.25em;
  box-shadow: 1px 1px;
}
details .grid p:has(:checked) {
  color: blue;
}
details .grid p label {
  flex: 1;
}
#group:has(details div.grid:empty) {
  display: none;
}
tr:hover> td{
  box-shadow:inset 0 0 0 20px #ADD8E644;
}
table tr> :first-child {
  width:15em;
  border-inline-end: solid black;
}
table tr> :nth-child(2){
  border-inline-end: solid black;
}
tr:has(input:checked),
tr:has(input:checked) td:not(td.rp:has(input:checked)) ~ td[class] {
  background: #FFC0C0;
  background: linear-gradient(#F00,#F00) 0 0 / 100% 2px no-repeat;
  color:#F50;
}

/*tr:not(:has(.rp input:checked)) td,
tr:not(:has(td.rp input:checked)) td.rp,*/
tr:has(td.rp input:checked) td ~ td.rp:has(input:checked),
table tr td.rp:has(input:checked) ~ td.rp:not(:has(input:checked)) {
  background: #E1FBE1;
}
table {
  table-layout: fixed;
  width: 100%;
}

table tr>*:not(:first-child) {
  text-align: center;
}

table tr> *,
table label {
  overflow: hidden;
  white-space: nowrap;
  text-overflow: ellipsis;
}
.pagination-container {
  width: calc(100% - 2rem);
  display: flex;
  align-items: center;

  padding: 1rem 0;
  justify-content: center;
}
 
.pagination-number,
.pagination-button{
  font-size: 1.1rem;
  background-color: silver;
  border: none;
  margin: 0.25rem 0.25rem;
  cursor: pointer;
  height: 2.5rem;
  width: 2.5rem;
  border-radius: 5px;
  color:black;
}
 
.pagination-number:hover,
.pagination-button:not(.disabled):hover {
  background: #fff;
}
 input[type=submit].checked ,
.pagination-number.active {
  color: #fff;
  background: #2374FF;
  border-radius: 5px;
}

.hidden {
  display: none;
}
tr:has(.draft) * {
  color:gray;
  font-style:italic;
}
tr:has(.draft) {
  box-shadow:inset 0 0 0 2em #0001
}
</style>
<form action="plugin.php?p=<?= basename(__DIR__) ?>" method="post" >
	<h3><?php $plxPlugin->lang("L_SELECT_MEMBER_ACCESS") ?></h3>
	<fieldset id="group"><legend>Groupes Pages statiques</legend>		
		<details><summary>Afficher la liste.</summary>	
			<div class="grid"></div>
		</details>
	</fieldset>
	<fieldset><legend><?= L_MENU_STATICS ?></legend>		
		<details><summary><?= $plxPlugin->lang('L_SHOW')?></summary>	
			<div class="grid">
				<?= $statsPage ?>
			</div>
		</details>
	</fieldset>
	<fieldset><legend><?= L_MENU_ARTICLES ?></legend>
		<details><summary><?= $plxPlugin->lang('L_SHOW')?></summary>	
			<div>
				<?= $articlePage ?>
			</div>
		</details>
	</fieldset>
	<fieldset><legend><?= L_MENU_CATEGORIES ?></legend>
		<details><summary><?= $plxPlugin->lang('L_SHOW')?></summary>	
			<div class="grid">
				<?= $categoriePage ?>
			</div>
		</details>		
	</fieldset>
	
	<p class="in-action-bar">
		<?php echo plxToken::getTokenPostMethod() ?><br>
		<input type="submit" name="submit" value="<?= $plxPlugin->getLang('L_SAVE') ?>"/>
	</p>
</form>
<script>
	const group = document.querySelectorAll('form [data-group]');
	const fieldGroup = document.querySelector('#group div.grid');
	let disabledRadios = document.querySelectorAll('table tbody tr:not(:has(td.rp input:checked)) input[type="radio"]');
	let checkBoxes = document.querySelectorAll('table tbody tr input[type="checkbox"]');

	let groupArray={};
	for(i=0;group.length>i;i++){
		let key = group[i].dataset.group;
		if(key !=''  ) {
			if( typeof groupArray[key] !== 'undefined') {groupArray[key] =  groupArray[key] +'|'+group[i].getAttribute('id').slice(-3);}
			else groupArray[key] = group[i].getAttribute('id').slice(-3);
		}
	}
	
	// insertion de groupes de pages statiques
	for (let key in groupArray) {
		let p = document.createElement('p')
		let label = document.createElement('label')
		label.setAttribute('for',key);
		label.textContent = key;
		// ajout label
		p.appendChild(label)
		let input = document.createElement('input')
		input.setAttribute('id',key)
		input.setAttribute('type','checkbox')
		input.setAttribute('value',groupArray[key])
		
		// sont-elles déjà toutes séléctionnées
		let checkedIpt = true;
		let stateGroup  = groupArray[key].split("|");
		for(si=0;stateGroup.length > si ;si++ ){
			if(document.querySelector('#stat-'+stateGroup[si]+':not(:checked)')) checkedIpt =false;
		}
		if(checkedIpt === true)   input.setAttribute('checked','checked')
		// ajout input
		p.appendChild(input)
		// insertion du paragraphe
		fieldGroup.appendChild(p)
		// ajout listener sur input
		document.querySelector('#'+key).addEventListener(
		'change',
		function(){ 
			toggleSelGroup(this)
		},
		false)
	}
	
	function toggleSelGroup(el){
		let stats =el.value.split("|");
		for(stat=0;stats.length>stat;stat++){
			if(el.checked) {
				let ckb=	document.querySelector('#stat-'+stats[stat]);
				ckb.setAttribute('checked','checked')
				togglechecked(ckb)
			} 
			else {
				let ckb=document.querySelector('#stat-'+stats[stat])
				ckb.removeAttribute('checked')
				togglechecked(ckb)
			}
		}
	}
	function checkRadios(disabledRadios) {
		let allRadios = document.querySelectorAll('table tbody tr input[type="radio"]' );
		allRadios.forEach((el) => {
			el.removeAttribute("disabled");
		});
		disabledRadios.forEach((el) => {
			el.setAttribute("disabled", "disabled");
			el.removeAttribute("checked");
		});
	}
	checkBoxes.forEach((el) => {
	  el.addEventListener("change", () => {
		togglechecked(el);
	  });
	});
	function togglechecked(el) {
		let Radios = el.closest("tr").querySelectorAll(' input[type="radio"]');
		if (el.checked) {
		  el.setAttribute("checked", "checked");
		  Radios.forEach((r) => {
			r.removeAttribute("disabled");
		  });
		  Radios[0].checked = true;
		} else {
		  Radios.forEach((r) => {
			r.setAttribute("disabled", "disabled");
			r.checked = false;
		  });
		}	
	}
	window.addEventListener("load", checkRadios(disabledRadios));

	let paginationLimit = <?= $plxPlugin->paginateBy ?>;
// Pagination tableau
window.addEventListener("load", function () {
	  const paginationNumbers = document.getElementById("pagination-numbers");
	  const paginatedList = document.getElementById("tableArts");
	  const listItems = paginatedList.querySelectorAll("tbody tr");
	  const nextButton = document.getElementById("next-button");
	  const prevButton = document.getElementById("prev-button");

	  const pageCount = Math.ceil(listItems.length / paginationLimit);
	  const nbsub = paginatedList.querySelector("thead sup");
	  nbsub.textContent = listItems.length + " " + nbsub.textContent;
	  let currentPage = 1;

	  const disableButton = (button) => {
		button.classList.add("disabled");
		button.setAttribute("disabled", true);
	  };

	  const enableButton = (button) => {
		button.classList.remove("disabled");
		button.removeAttribute("disabled");
	  };

	  const handlePageButtonsStatus = () => {
		if (currentPage === 1) {
		  disableButton(prevButton);
		} else {
		  enableButton(prevButton);
		}

		if (pageCount === currentPage) {
		  disableButton(nextButton);
		} else {
		  enableButton(nextButton);
		}
	  };

	  const handleActivePageNumber = () => {
		document.querySelectorAll(".pagination-number").forEach((button) => {
		  button.classList.remove("active");
		  const pageIndex = Number(button.getAttribute("page-index"));
		  if (pageIndex == currentPage) {
			button.classList.add("active");
		  }
		});
	  };

	  const appendPageNumber = (index) => {
		const pageNumber = document.createElement("button");
		pageNumber.className = "pagination-number";
		pageNumber.innerHTML = index;
		pageNumber.setAttribute("page-index", index);
		pageNumber.setAttribute("aria-label", "Page " + index);

		paginationNumbers.appendChild(pageNumber);
	  };

	  const getPaginationNumbers = () => {
		for (let i = 1; i <= pageCount; i++) {
		  appendPageNumber(i);
		}
	  };

	  const setCurrentPage = (pageNum) => {
		currentPage = pageNum;

		handleActivePageNumber();
		handlePageButtonsStatus();

		const prevRange = (pageNum - 1) * paginationLimit;
		const currRange = pageNum * paginationLimit;

		listItems.forEach((item, index) => {
		  item.classList.add("hidden");
		  if (index >= prevRange && index < currRange) {
			item.classList.remove("hidden");
		  }
		});
	  };

	  getPaginationNumbers();
	  setCurrentPage(1);

	  prevButton.addEventListener("click", () => {
		setCurrentPage(currentPage - 1);
		event.preventDefault();
	  });

	  nextButton.addEventListener("click", () => {
		setCurrentPage(currentPage + 1);
		event.preventDefault();
	  });

	  document.querySelectorAll(".pagination-number").forEach((button) => {
		const pageIndex = Number(button.getAttribute("page-index"));

		if (pageIndex) {
		  button.addEventListener("click", () => {
			setCurrentPage(pageIndex);
			event.preventDefault();
		  });
		}
	  });
});
</script>